namespace Quik.Typography
{
    public interface IQuikFontManager
    {
        /// <summary>
        /// The context owning the font manager.
        /// </summary>
        QuikContext Context { get; set; } 
        
        /// <summary>
        /// Function called on clear.
        /// </summary>
        void Clear();

        /// <summary>
        /// Get a font object for the given font.
        /// </summary>
        /// <param name="fontStyle">The font style to fetch.</param>
        /// <returns>The font.</returns>
        QuikFont GetFont(QuikFontStyle fontStyle);
    }
}